//	wt]xH쎺	http://jsdiy.starfree.jp
//	2022/05

#include <avr/io.h>
#include "application.h"
#include "em7slib.h"
#include "segment.h"
#include "button4.h"
#include "wdtsleep.h"

//s
typedef	enum
{
	ST_Reset,
	ST_Setting,		//JEg_E^C}[Zbg
	ST_Play,		//^C}[쒆
	ST_Pause,		//^C}[ꎞ~
	ST_End			//^C}[I
}
EStatus;

//{^̃CfbNX
enum { IDX_BUTTON_TEN = 0, IDX_BUTTON_ONE, IDX_BUTTON_START, IDX_SWITCH_UNIT };

//^C}[̒P
typedef	enum
{
	UnitMinute,	//
	UnitSecond	//b
}
ETimerUnit;

//\̈ʁÄ
#define	TEN(a)	((a) / 10)
#define	ONE(a)	((a) % 10)

//Zbgꂽԁ^JEg̎
typedef	struct
{
	uint8_t	minute, second;
	uint8_t	reminingMinute;
}
TCountTime;

//ϐ
static	EStatus status;
static	uint8_t	segNums[] = { SEG_0, SEG_1, SEG_2, SEG_3, SEG_4, SEG_5, SEG_6, SEG_7, SEG_8, SEG_9 };
static	uint8_t	countValue;
static	uint8_t	timerUnit;
static	TCountTime	countTime;

//֐
static	uint8_t	IsPushPauseButton(void);
static	void	WaitReleasePauseButton(void);
static	uint8_t	IsPushResetButton(void);
static	void	WaitReleaseResetButton(void);
static	void	APP_Reset(void);
static	void	APP_Setting(void);
static	void	APP_Play(void);
static	void	DecrementCount(void);
static	void	DisplayCount(void);
static	void	APP_Pause(void);
static	void	APP_End(void);


//Avs
void	APP_Exec(void)
{
	status = ST_Reset;
	
	EM7S_Init();
	Button_Init();
	
	while (1)
	{
		//sԂɍ킹
		switch (status)
		{
		case ST_Reset:		APP_Reset();	break;
		case ST_Setting:	APP_Setting();	break;
		case ST_Play:		APP_Play();		break;
		case ST_Pause:		APP_Pause();	break;
		case ST_End:		APP_End();		break;
		default:	break;
		}
	}
}

//{^Ă邩
static	uint8_t	IsButtonPush(uint8_t btnIndex)
{
	return
		Button_Status(btnIndex) == ButtonOn ||
		Button_Status(btnIndex) == ButtonShortHold ||
		Button_Status(btnIndex) == ButtonLongHold;
}

//ꎞ~{^ꂽ
static	uint8_t	IsPushPauseButton(void)
{
	return	IsButtonPush(IDX_BUTTON_START);
}

//ꎞ~{^܂ő҂
static	void	WaitReleasePauseButton(void)
{
	while (IsPushPauseButton())
	{
		WDT_SleepMSec(WDTO_120MS, 1);
		Button_Read();
	}
}

//Zbg{^ꂽ
static	uint8_t	IsPushResetButton(void)
{
	return	IsButtonPush(IDX_BUTTON_TEN) && IsButtonPush(IDX_BUTTON_ONE);
}

//Zbg{^܂ő҂
static	void	WaitReleaseResetButton(void)
{
	while (IsButtonPush(IDX_BUTTON_TEN) || IsButtonPush(IDX_BUTTON_ONE))
	{
		WDT_SleepMSec(WDTO_120MS, 1);
		Button_Read();
	}
}

//ԂɃZbg
static	void	APP_Reset(void)
{
	//u00vƕ\
	countValue = 0;
	EM7S_Update(1, segNums[TEN(countValue)]);
	EM7S_Update(2, segNums[ONE(countValue)]);
	
	WaitReleaseResetButton();
	status = ST_Setting;
}

//JEg_E^C}[̎ԂZbg
static	void	APP_Setting(void)
{
	//{^ǂݍ
	WDT_SleepMSec(WDTO_120MS, 1);
	Button_Read();
	
	//Zbgvꂽꍇ
	if (IsPushResetButton())
	{
		status = ST_Reset;
		return;
	}
	
	//\̈
	if (Button_Status(IDX_BUTTON_TEN) == ButtonOn)
	{
		countValue += (countValue < 90 ? 10 : -90);
		EM7S_Update(1, segNums[TEN(countValue)]);
	}
	
	//̈
	if (Button_Status(IDX_BUTTON_ONE) == ButtonOn)
	{
		countValue += (ONE(countValue) < 9 ? 1 : -9);
		EM7S_Update(2, segNums[ONE(countValue)]);
	}
	
	//X^[g
	if (Button_Status(IDX_BUTTON_START) == ButtonOn && 0 < countValue)
	{
		//b
		if (Button_Status(IDX_SWITCH_UNIT) == ButtonReleased)
		{
			timerUnit = UnitMinute;
			countTime.minute = countValue;
			countTime.second = 0;
		}
		else
		{
			timerUnit = UnitSecond;
			countTime.minute = 0;
			countTime.second = countValue;
		}
		
		status = ST_Play;
		return;
	}
}

//JEg_E
static	void	APP_Play(void)
{
	//JEg_Ê߂1bX[v^A
	WDT_SleepSec(1);
	
	//{^ǂݍ
	Button_Read();
	
	//Zbgvꂽꍇ
	if (IsPushResetButton())
	{
		status = ST_Reset;
		return;
	}

	//ꎞ~vꂽꍇ
	if (IsPushPauseButton())
	{
		WaitReleasePauseButton();
		status = ST_Pause;
		return;
	}
	
	//JEg1炷
	DecrementCount();
	
	//c莞Ԃ\
	DisplayCount();
	
	//^C}[̏ꍇ
	if (countTime.minute == 0 && countTime.second == 0)
	{
		WDT_SleepMSec(WDTO_500MS, 1);	//0.5bX[v^Ai]Ĉ߁j
		status = ST_End;
		return;
	}
}

//1b炷
static	void	DecrementCount(void)
{
	if (countTime.second == 0)
	{
		countTime.minute--;
		countTime.second = 60;
	}
	
	if (0 < countTime.second)
	{
		countTime.second--;
		if (countTime.second == 0) { countTime.reminingMinute = countTime.minute; }
	}
}

//c莞Ԃ\
static	void	DisplayCount(void)
{
	if (timerUnit == UnitMinute &&
		(	(55 < countTime.second && countTime.minute < countValue - 1) || (countTime.second == 0 && 0 < countTime.minute)	)
		)
	{
		//ćubv̏̂ƂAćuv\i[pfBOŁj
		EM7S_Update(1, segNums[TEN(countTime.reminingMinute)]);
		EM7S_Update(2, segNums[ONE(countTime.reminingMinute)]);
	}
	else
	{
		//ćubv\i[TvXŁj
		uint8_t ten = TEN(countTime.second);
		EM7S_Update(1, 0 < ten ? segNums[ten] : SEG_null);
		EM7S_Update(2, segNums[ONE(countTime.second)]);
	}
}

//JEg_Eꎞ~
static	void	APP_Pause(void)
{
	//{^ǂݍ
	WDT_SleepMSec(WDTO_120MS, 1);
	Button_Read();
	
	//Zbgvꂽꍇ
	if (IsPushResetButton())
	{
		status = ST_Reset;
		return;
	}
	
	//ꎞ~ꂽꍇ
	if (IsPushPauseButton())
	{
		WaitReleasePauseButton();
		status = ST_Play;
		return;
	}
}

//^C}[
static	void	APP_End(void)
{
	uint8_t	bitPattern;
	
	//k\ԂAZOgAF܂1ZOgړ悤ȓŕ\
	for (uint8_t i = 0; i < 6; i++)
	{
		bitPattern = (1 << i);
		EM7S_Update(1, bitPattern);
		EM7S_Update(2, bitPattern);
	}
	
	//k\ԂAZOgAF܂ŏ\
	bitPattern = 0;
	for (uint8_t i = 0; i < 6; i++)
	{
		bitPattern |= (1 << i);
		EM7S_Update(1, bitPattern);
		EM7S_Update(2, bitPattern);
	}
	
	//u0v\ꂽԂAZOgAF܂ŏ\
	bitPattern = 0x3F;
	for (uint8_t i = 0; i < 6; i++)
	{
		bitPattern &= ~(1 << i);
		EM7S_Update(1, bitPattern);
		EM7S_Update(2, bitPattern);
	}
	
	//]Ĉ߂̑҂
	WDT_SleepMSec(WDTO_500MS, 1);
	
	//ŏɖ߂
	status = ST_Reset;
}
