//	wt]xH쎺	http://jsdiy.starfree.jp
//	2022/05

#include <avr/io.h>
#include "button4.h"


//e{^̏
//bit	:7 6 5 4  :3      :2 1 0       :
//		:holdCount:prevPin:EButtonState:
#define	BITPOS_HOLDCOUNT	4
#define	BITPOS_BTNPIN		3
#define	BITPOS_EBTNSTATE	0
//
#define	MASK_HOLDCOUNT	0x0F
#define	MASK_BTNPIN		0x01
#define	MASK_EBTNSTATE	0x03

//{^̌
#define	NUMOF_BUTTON	4

//{^̔z
static	uint8_t	btnInfos[NUMOF_BUTTON];

//
void	Button_Init(void)
{
	//|[gݒ肷
	BUTTON_DDR	&= ~(BUTTON_A_BV | BUTTON_B_BV | BUTTON_C_BV | BUTTON_D_BV);	//͕
	BUTTON_PORT	|= (BUTTON_A_BV | BUTTON_B_BV | BUTTON_C_BV | BUTTON_D_BV);		//vAbv
	
	for (uint8_t i = 0 ; i < NUMOF_BUTTON; i++) { btnInfos[i] = 0x00; }
}

//{^̉Ԃ𔻒肷
//E̊ԊuŌĂяoĒÕ{^ԂƔr邱ƂŌ݂̏Ԃ𔻒肷B
void	Button_Read(void)
{
	uint8_t targetBtnsBV[] = { BUTTON_A_BV, BUTTON_B_BV, BUTTON_C_BV, BUTTON_D_BV };

	//̓WX^ǂݍށi{^̓͏ԂɎ擾łj
	uint8_t	inputState = ~BUTTON_PIN;	//ꂽ{^̃rbg'1'AȊO'0'
	
	for (uint8_t i = 0 ; i < NUMOF_BUTTON; i++)
	{
		uint8_t btnInfo = btnInfos[i];
		uint8_t targetBtnBV = targetBtnsBV[i];
	
		//Õ{^
		uint8_t holdCount = (btnInfo >> BITPOS_HOLDCOUNT) & MASK_HOLDCOUNT;
		uint8_t	prevBtnPin = (btnInfo >> BITPOS_BTNPIN) & MASK_BTNPIN;
		
		//݂̃{^Ԃ擾
		uint8_t	nowBtnPin = (inputState & targetBtnBV) ? 1 : 0;
	
		//{^̉ԂXV
		EButtonState eBtnState;
		if (prevBtnPin == 0 && nowBtnPin == 1)
		{
			eBtnState = ButtonOn;
		}
		else if (prevBtnPin == 1 && nowBtnPin == 1)
		{
			if (holdCount == MAX_HOLD_COUNT)
			{
				eBtnState = ButtonLongHold;
			}
			else
			{
				eBtnState = ButtonShortHold;
				holdCount++;
			}
		}
		else if (prevBtnPin == 1 && nowBtnPin == 0)
		{
			eBtnState = ButtonOff;
			holdCount = 0;
		}
		else
		{
			eBtnState = ButtonReleased;
		}
		
		//{^XV
		btnInfo = (holdCount << BITPOS_HOLDCOUNT) | (nowBtnPin << BITPOS_BTNPIN) | (eBtnState << BITPOS_EBTNSTATE);
		btnInfos[i] = btnInfo;
	}
}

//{^̉Ԃ擾
//EButton_Read()̌ɌĂяoB
EButtonState	Button_Status(uint8_t btnIndex)
{
	return (btnInfos[btnIndex] & MASK_EBTNSTATE);
}
