//	em7slib		Electronicmagnetic 7-segment module driver
//wt]xH쎺	@jsdiy	http://jsdiy.starfree.jp
//	2021/09

#ifndef EM7SLIB_H_
#define EM7SLIB_H_


#define	EM7S_PORT	PORTB
#define	EM7S_DDR	DDRB

#if (0)	//ATmega328P
#define	EM7S_DIG_RCK	(1 << PORTB5)	//RCK[dig]
#define	EM7S_SEG_RCK	(1 << PORTB4)	//RCK[seg]
#define	EM7S_SEG_SCK	(1 << PORTB3)	//SRCK[seg]
#define	EM7S_SRCLR		(1 << PORTB2)	//SRCLR (active-low)
#define	EM7S_SRIN		(1 << PORTB1)	//SR-IN
#define	EM7S_DIG_SCK	(1 << PORTB0)	//SRCK[dig]
#else	//ATtiny2313
//̃s̕я
#define	EM7S_SEG_RCK	(1 << PB5)	//RCK[seg]
#define	EM7S_SEG_SCK	(1 << PB4)	//SRCK[seg]
#define	EM7S_SRCLR		(1 << PB3)	//SRCLR (active-low)
#define	EM7S_SRIN		(1 << PB2)	//SR-IN
#define	EM7S_DIG_RCK	(1 << PB1)	//RCK[dig]
#define	EM7S_DIG_SCK	(1 << PB0)	//SRCK[dig]
#endif

//֐
void	EM7S_Init(void);
void	EM7S_Standby(void);
void	EM7S_Update(uint8_t digit, uint8_t segmentPattern);


#endif	//EM7SLIB_H_
