//	wt]xH쎺	http://jsdiy.starfree.jp
//	2022/05
//	ATmega328P

#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>
#include "wdtsleep.h"

//WDT̃^C}[Ԃ̍Ē`(4b,8b)
//EWDTCSRWX^WDP3̃rbgʒuł̂ŁAWDTO_4S,WDTO_8Swdt.hŒ`ꂽlCKviwdt.hQƁjB
//EWDTO_15MS`WDTO_2S̒`͏CKvȂB
#define WDT_WDP_4SEC	(((WDTO_4S & 0x08) << 2) | (WDTO_4S & 0x07))	//4s:----1000  --1--000
#define WDT_WDP_8SEC	(((WDTO_8S & 0x08) << 2) | (WDTO_8S & 0x07))	//8s:----1001  --1--001

//֐
static	void	WdtPrescaler(uint8_t bvWDP);
static	void	WdtDisable(void);

//WDT荞
#if (0)	//ATmega328P
ISR(WDT_vect)
{
	//
}
#else	//ATtiny2313
ISR(WDT_OVERFLOW_vect)
{
	//
}
#endif

//nbԎԑ҂
void	WDT_SleepSec(uint8_t sec)
{
	WDT_SleepMSec(WDTO_1S, sec);
}

//~bԁ~n̎ԑ҂
void	WDT_SleepMSec(uint8_t wdtoValue, uint8_t loop)
{
	WdtPrescaler(wdtoValue);	//WDT̃vXP[ݒ肷
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);	//X[v[hݒ肷
	
	for (uint8_t i = 0; i < loop; i++)
	{
		WDTCSR |= (1 << WDIE);	//WDT荞݂ivJnj
		sei();
		sleep_mode();	//X[vJn^荞ݔ^
		cli();
	}
	
	WdtDisable();	//WDT֎~ivXP[Zbgj
}

//WDT̎ԊԊuݒ肷
//:	WDTO_15MS, WDTO_30MS, WDTO_60MS, WDTO_120MS, WDTO_250MS, WDTO_500MS, WDTO_1S, WDTO_2S,
//		WDT_WDT_4SEC, WDT_WDT_8SEC
static	void	WdtPrescaler(uint8_t bvWDP)
{
	WDTCSR |= (1 << WDCE) | (1 << WDE);
	WDTCSR = (1 << WDE) | bvWDP;
}

//WDT֎~
static	void	WdtDisable(void)
{
	wdt_reset();
	MCUSR = 0x00;	//MCUSRiZbg񃌃WX^jNA
	WDTCSR |= (1 << WDCE) | (1 << WDE);	//(1)WDT֎~邽߂ɂ͈UWDErbg'1'Kv
	WDTCSR = 0x00;						//(2)̒4clkȓWDErbg'0'Ƃŋ֎~ł
}
